<template>
  <div>
    <sms-form :showButton="false"
              :changePhone="false"
              :resendUrl="checkUrl"
              nameError="errorSign"
              v-model="$user.smsCode"
              @change="handleSms"
              @enter="sign"
    >
      <template slot="title">
        Подписание {{$helpers.plural(agreementCount, ['договора', 'договоров'])}}
      </template>
      <template slot="'additional-title'">
        Для подписания {{$helpers.plural(agreementCount, ['договора', 'договоров'])}} введите код подтверждения
        из SMS.
      </template>
      <template slot="agreement">
        <div class="checkbox">
          <ui-checkbox v-model="agree" style="padding-left: 10px"></ui-checkbox>
          Вводя код подтверждения, вы принимаете
          <a v-if="agreementCount === 1" href="#" @click.stop.prevent="loanAgreement">условия
            договора.</a>
          <a v-if="agreementCount === 2" href="#" @click.stop.prevent="showMe">условия договоров.</a>
        </div>
      </template>
    </sms-form>
    <modal name="show-terms-of-contracts"
           :adaptive="true"
           :scrollable="true"
           class="arcticmodal-container"
           height="auto"
           width="700"
    >
      <div class="container m-header">
        <div @click="close()" class="box-modal_close arcticmodal-close"></div>
        <div class="row">
          <div class="column text-center">
            <h3>Список договоров по подписанию займа</h3>
          </div>
        </div>
      </div>
      <div class="container content feedback-block">
        <div class="row details">
          <a @click.stop.prevent="loanAgreement" href="#">
            <div class="picto"><img src="/lk/static/img/notification/docs.png" alt="">
            </div>
            Договор нецелевого потребительского займа (микрозайма) №{{loanId}}
          </a>
        </div>
        <div class="row details">
          <a @click.stop.prevent="insuranceAgreement" href="#">
            <div class="picto"><img src="/lk/static/img/notification/docs.png" alt="">
            </div>
            Договор страхования потребительского займа (микрозайма) №{{posId}}
          </a>
        </div>
      </div>
    </modal>
    <warning-message></warning-message>
    <success-message></success-message>
    <button @click="sign"
            :disabled="!agree || $interface.buttonLoading"
            :class="{button_loading: $interface.buttonLoading}"
    >Подписать
    </button>
  </div>
</template>

<script>
  import { REQUIRED_FIELD, LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage'
  import backendApi from '@/utils/backend-api'
  import { errorSign } from '@/utils/error/sign'
  import smsErrors from '@/utils/error_mapper/smsErrors'

  import SmsForm from '@/components/SmsForm'

  const contractTypeMessageMapper = {
    contract: {
      action: 'signLoan',
      resendAction: 'resendSMSLoan'
    },
    suplementary: {
      messages: {
        title: 'Подписание дополнительного соглашенимя',
        body: 'допсоглашения',
        footer: 'Я принимаю условия допсоглашения.'
      },
      action: 'signSupplementary',
      resendAction: 'resendSMSSupplementary'
    }
  }

  export default {
    name: 'Signing',
    mixins: [
      ErrorHandleMixin,
      GetValidateClass
    ],
    props: {
      ContractType: {
        required: true
      }
    },
    data () {
      return {
        title: 'Подписание договора',
        blockContacts: false,
        contract: contractTypeMessageMapper[this.ContractType],
        agree: true,
        loaderButtonClass: false,
        smsCode: '',
        loanId: '',
        documentNumber: ''
      }
    },
    components: {
      ValidateMessage,
      WarningMessage,
      SuccessMessage,
      SmsForm
    },
    computed: {
      agreementCount () {
        return this.$posServices ? 2 : 1
      },
      checkUrl () {
        return this.$pdl.type === 8 ? this.$backend.api.installment.sign.resendUrl : this.$backend.api.loan.sign.resendUrl
      },
        posId () {
          return this.$posServices?.id;
        }
    },
    methods: {
      handleSms (sms) {
        this.smsCode = sms;
      },
      async sign () {
        const validate = await this.$validator.validateAll();
        if (validate) {
          this.BUTTON_LOADING(true);
          this.AJAX_LOADING(true);
          let method = (this.$pdl.type === 8) ? 'installment' : 'loan'; // для запроса
          this.$backend.api[method].sign.sign(this.smsCode).then(({data}) => {
            this.$backend.log({
                                action: 'singing',
                                user_id: this.$user.id,
                                user_login: this.$user.login,
                                code: this.smsCode,
                                creditId: this.$pdl.id,
                                creditSum: this.$pdl.sum,
                                type: this.$pdl.type
                              });
            const promises = [];
            promises.push(this.$store.dispatch('GET_LOAN_PDL'));
            promises.push(this.$store.dispatch('GET_LOAN_POS'));
            this.$helpers.scroll(this.$root.$el);
            if (this.$pdl.type === 1) {
              this.$toastr.success('Договор подписан. Дождитесь СМС о переводе.', 'Успешно');
            } else if (this.$pdl.type === 8) {
              this.$toastr.success('Договор подписан. Убедитесь, что вы прошли идентификацию.', 'Успешно');
            }

            return Promise.all(promises).finally(() => {
              this.AJAX_LOADING(false);
              this.$helpers.scroll(this.$root.$el);
            });
          }).catch((e) => {
            this.$error(e, smsErrors, 'Ошибка подписания договора');
          }).finally(() => {
            this.BUTTON_LOADING(false);
          })

        } else {
          this.$refs.cs.focus();
        }
      },
      showMe () {
        this.$modal.show('show-terms-of-contracts')
      },
      async loanAgreement () {
        const win = window.open('about:blank', 'target=_blank', 'status=0,title=0,height=600,width=1000,scrollbars=1')
        await this.$backend.api.documents.byUrl(`loan/html/${this.loanId}`).then(res => {
          this.documentNumber = res.data
          win.document.write(this.documentNumber)
        })
      },
      async insuranceAgreement () {
        // await backendApi.getData(`documents/loan/html/${this.posId}`).then(res => console.log('@@@@', res))

          const win = window.open('about:blank', 'target=_blank', 'status=0,title=0,height=600,width=1000,scrollbars=1')
          await this.$backend.api.documents.byUrl(`loan/html/${this.posId}`).then(res => {
              this.documentNumber = res.data
              win.document.write(this.documentNumber)
          })
      },
      close () {
        this.$modal.hide('show-terms-of-contracts')
      }
    },
    async created () {
      if (this.$posServices) {
        this.title = 'Подписание договоров';
        this.blockContacts = true
      }
      this.loanId = this.$pdl.id;
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD);
      this.$validator.localize(LENGHT);
    }
  }
</script>

<style scoped lang="scss">
  input {
    min-width: 185px
  }

  .refresh {
    margin-bottom: 40px
  }
</style>
